<template>
  <div/>
</template>

<script>
import axios from 'axios'
import moment from 'moment'
import { geoJSON, marker, divIcon } from 'leaflet'
import WorkspaceGetter from '@/workspace/mixins/WorkspaceGetter'
import LeafletGetter from '@/workspace/mixins/LeafletGetter'
import { SET_WORKSPACE_QUERY } from '@/workspace/store/mutations'

export default {
  name: 'geojsonlayer',

  mixins: [
    WorkspaceGetter,
    LeafletGetter
  ],

  props: {
    layerId: {
      type: String,
      required: true
    }
  },

  computed: {
    layer: {
      get () {
        return this.$store.getters.workspaceLayerById(this.workspaceId, this.layerId)
      }
    },

    time: {
      get () {
        return this.workspaceComponent.time
      }
    },

    status: {
      get () {
        return this.layer.status
      }
    }
  },

  watch: {
    async time () {
      const data = await this.getData()
      this.clear().setData(data)
    },

    status () {
      if (this.status) {
        this.__leafletObject.addTo(this.leafletMap)
      } else {
        this.__leafletObject.remove()
      }
    }
  },

  methods: {
    async getData () {
      const url = process.env.VUE_APP_BASE_STATIONS_URL + '/' + this.layer.name
      const response = await axios.get(url, {
        params: {
          time: moment.unix(this.time).format('YYYY-MM-DDTHH:mm:00[Z]')
        }
      })
      return response.data
    },

    clear() {
      this.__leafletObject.clearLayers()
      return this
    },

    setData(data) {
      this.clear().__leafletObject.addData(data)
      return this
    },

    setStyle(style) {
      this.__leafletObject.setStyle(style)
      return this
    }
  },

  async mounted() {
    const data = await this.getData()

    this.__leafletObject = geoJSON(data, {
      filter: (point) => {
        return point.properties[this.layer.name] !== null
      },
      pointToLayer: (point, latlng) => {
        return marker(latlng, {
          icon: divIcon({
            className: this.layer.name + '-station-icon station-icon',
            html: point.properties[this.layer.name] + ' ' + point.properties.units,
            iconSize: [36, 36]
          })
        }).on('click', () => {
          window.console.log(point)
          this.$nextTick(() => {
            this.$store.commit(SET_WORKSPACE_QUERY, {
              workspaceId: this.workspaceId,
              query: {
                isStation: true,
                stationId: point.properties.station_id,
                latitude: latlng.lat,
                longitude: latlng.lng
              }
            })
          })
        })
      },
    })//.addTo(this.leafletMap)

    if(this.layer.status) {
      this.__leafletObject.addTo(this.leafletMap)
    }
  }
}
</script>

<style>
.station-icon {
  background: red;
  text-align: center;
  border-radius: 50%;
  text-align: center;
  line-height: 36px;
  font-size: 0.65rem;
}

.pressure-station-icon {
  background: #2323e9;
  color: white;
}

.temperature-minimum-station-icon {
  background: #d54590;
}

.temperature-mean-station-icon {
  background: #f54530;
}

.temperature-maximum-station-icon {
  background: #f02323;
}

.relative-humidity-minimum-station-icon {
  background: #23d512;
}

.relative-humidity-maximum-station-icon {
  background: #23d512;
}

.relative-humidity-mean-station-icon {
  background: #23d512;
}

.wind-direction-mean-station-icon {
background: #565690;
}

.wind-direction-maximum-station-icon {
  background: #4949af;
}

.wind-intensity-mean-station-icon {
  background: #d9d995;
}

.wind-maximum-intensity-station-icon {
  background: #c9c980;
}

.precipitation-station-icon {
  background: #3232e9;
  color: white;
}

.precipitation-maximum-station-icon {
  background: #2121f5;
  color: white;
}
</style>
